<?php
/*
Copyright (c) 2008 http://ramui.com. All right reserved.
This product is protected by copyright and distributed under licenses restricting copying, distribution. Permission is granted to the public to download and use this script provided that this Notice and any statement of authorship are reproduced in every page on all copies of the script.
*/
class admin
{
private $url;
private $user;
private $pw;
private $language;
private $list_perpage=10;
private $filename="database/db.php";
private $configfile='database/config.php';

private function validate_user()
{
        if (!($this->validate_url())){return false;}
        if ($this->validate_pw()){return true;}
        if (file_exists("database/settings.php")){
            $f=file("database/settings.php");
            return ((@($_SESSION['admin'])=='yes') && ($f[1]==bin2hex($this->pw).bin2hex($this->user).bin2hex($_SERVER['REMOTE_ADDR'])));}
        return false;
}
private function validate_url()
{
        $selfurl = str_replace("www.","", strtolower(getenv("HTTP_HOST")));
        return ($selfurl===$this->url);
}
private function validate_pw()
{
        if (empty($_POST['password'])||empty($_POST['name'])){return false;}
        $_SESSION['try']=((isset($_SESSION['try']))? 1+$_SESSION['try'] : 1);
        if(@$_SESSION['try'] > 3){return false;}
        $name=@bin2hex($this->strip_slashes(trim($_POST['name'])));
        $pass=@md5($this->strip_slashes(trim($_POST['password'])));
        if(($pass==$this->pw)&&($name==bin2hex($this->user))){
            $_SESSION['admin']='yes';
            $_SESSION['try']=0;
            $handle=@fopen("database/settings.php" , 'w');
            fwrite($handle,"<?php exit; ?>");
            fwrite($handle,"\n");
            fwrite($handle, bin2hex($this->pw).bin2hex($this->user).bin2hex($_SERVER['REMOTE_ADDR']));
            fclose($handle);
            return true;}
        return false;
}
private function log_out()
{
        if(($_SESSION['admin'])=='yes'){
            unset($_SESSION['admin']);
            @file_put_contents("database/settings.php", "");
            $this->log_in();}
}
private function total_page($c, $p)
{
        if ($c<=1){return 0;}
        $d=$c-1;
        for ($i=1; $i<$c; $i++){
            $d=$d-$p;
            if ($d<=0){return $i;}}
}
private function build_page($title='')
{
        if($title==''){$title='Mailbox';}
        echo '<html xmlns="http://www.w3.org/1999/xhtml">
        <head>
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
        <title>'.$title.'</title>
        <link rel="stylesheet" type="text/css" href="screen.css" media="screen">
        <script type="text/javascript" src="script/admin.js"></script>
        </head>
        <body>
        <center>
        <div id="main">
        <div id="top">
        <img style="float:left;clear:left; border:none;" src="images/logo.gif"/>
        <div id="topmenu">
        &nbsp;|&nbsp;<a href="http://'.getenv("HTTP_HOST").'">Home</a>&nbsp;|&nbsp;';
        echo '&nbsp;|&nbsp;<a target="_blank" href="http://ramui.com/documentation/contact-form-without-mail-documentation.html">Documentation</a>
        &nbsp;|&nbsp;<a target="_blank" href="http://ramui.com/forum/viewforum.php?f=3">Help</a>';
        if ((isset($_SESSION['admin']))&&($_SESSION['admin'])=='yes'){echo '&nbsp;|&nbsp;&nbsp;|&nbsp;<a href="index.php?qur=5M1">Logout</a>';}
        echo '&nbsp;&nbsp;</div><br/><br/><span style="font-size:24px;"><i>PHP Contact form V4.0</i></span></div>';
}
private function show_empty()
{
        if (($_SESSION['admin'])=='yes'){
            unset($_SESSION['admin']);
            @file_put_contents("database/settings.php", "");}
        $this->build_page();
        echo 'Your Mailbox is empty!';
        $this->build_footer();
}
private function log_in()
{
        $this->build_page();
        echo '<form method="POST" style="text-align:left; padding-left:10px;" action="index.php"><br/><big><u>Administrator login:</u></big><table style="margin:10px;width:300px;"><tr><td>User:</td><td><input type="text" style="border:1px solid #c0c0c0;" name="name" size="20"></td></tr><tr><td>Password:</td><td><input type="password" style="border:1px solid #c0c0c0;" name="password" size="20"></td></tr><tr><td colspan="2" style="padding-top:20px;"><input type="submit" value="Submit" name="B1">&nbsp;&nbsp;<input type="reset" value="Reset" name="B2"></td></tr></table></form>';
        $this->build_footer();
}
private function show_list($page)
{
        $this->build_page();
        $lines=file($this->filename);
        $line_count=count($lines);
        $start_count=($line_count-1)-($page-1)*$this->list_perpage;
        $end_count=0;
        if($start_count>$this->list_perpage) {$end_count=$start_count-$this->list_perpage; }
        $totalpage=$this->total_page($line_count, $this->list_perpage);
        echo '<table id="mailbox"><tr style="background-color:#cccccc;"><td width="55%"><b>Subject</b></td><td width="25%"><b>From</b></td><td  width="20%"><b>Date</b></td></tr>';
        $ncolor=false;
        for($i=$start_count; $i>$end_count; $i--) {
            $ncolor=!$ncolor;
            $data=explode("<>", $this->strip_slashes($lines[$i]));
            if ($ncolor){echo '<tr style="background-color:#f0f0f0;">';}
            else {echo '<tr style="background-color:#e0e0e0;">';}
            echo '<td><a href="index.php?qur=1M'.$i.'">'.$data[1].'</a><br>'.$this->preview(trim($data[4])).'</td><td>'.$data[2].'</td><td>'.$data[3].'</td></tr>';}
        echo '<tr><td colspan="3"><b>No. of pages:&nbsp;'.$totalpage.'</b>&nbsp;&nbsp;&nbsp;';
        if ($page<=1){ echo '<span style="color:#808080;">Previous</span>&nbsp;|&nbsp';}
        else { echo '<a href="index.php?qur=0M1M'.($page-1).'">Previous</a>&nbsp;|&nbsp';}
        if ($page>=$totalpage){ echo '<span style="color:#808080;">Next</span>&nbsp;|&nbsp';}
        else { echo '<a href="index.php?qur=0M1M'.($page+1).'">Next</a>&nbsp;|&nbsp';}
        echo '</td></tr></table>';
        $this->build_footer();
}
private function preview($s)
{
        $str=str_replace('<p>', ' ', $s);
        $str=str_replace('</p>', ' ', $str);
        $str=str_replace('<br>', ' ', $str);
        $str=substr($str, 0, 127).'...';
        return $str;
}
private function show_message($message_number)
{
        $this->build_page('Message'.$message_number);
        $lines = file($this->filename);
        $data = explode("<>", $this->strip_slashes($lines[$message_number]));
        $next_number = $message_number+1;
        $previous_number = $message_number-1;
        $str=substr(bin2hex($data[1].$data[2].$data[3]),0,100);
        $str = "'?qur=2M".$message_number."M".$str."'";
        echo '<table id="menu"><tr><td><a href="index.php">Inbox</a></td><td><a href="#" onclick="javascript:fw_delete_message('.$str.')">Delete</a></td>';
        if ($message_number>1) { echo '<td><a href="index.php?qur=1M'.$previous_number.'">Previous Message</a></td>';}
        else{ echo '<td style="color:#cccccc;">Previous Message</td>';}
        if (($message_number+1)< count($lines)) { echo '<td><a href="index.php?qur=1M'.$next_number.'">Next Message</a></td>';}
        else{ echo '<td style="color:#cccccc;">Next Message</td>';}
        echo '<td><a href="index.php?qur=3M'.$message_number.'">Save text</a></td><td style="border:none;"><a href="index.php?qur=4M'.$message_number.'">Save html</a></td></tr></table>';
        echo '<div id="messagebox">From:&nbsp;<a href="mailto:'.$data[2].'">'.$data[5].'</a><br>IP:&nbsp;'.$data[0].'<br>Subject:&nbsp;'.$data[1].'<br>Date:&nbsp;'.$data[3].'<hr />'.$data[4].'</div>';
        $this->build_footer();
}
private function savemessage_html($message_number)
{
        $lines=file($this->filename);
        $d=explode("<>", $lines[$message_number]);
        $s='<html><head><title>Message'.$message_number.'</title></head><body><div style="width:600px;">';
        $s.='From:&nbsp;<a href="mailto:'.$d[2].'">'.$d[5].'</a><br/>I.P.:&nbsp;' .$d[0].'<br>Subject:&nbsp;'.$d[1].'<br>Date:&nbsp;'.$d[3].'<br/><hr/>'.$d[4].'</div></body></html>';
        $f='message'.$message_number.'.html';
        @header("Content-type: application/text");
        @header("Content-Disposition: attachment; filename=$f");
        echo $s;
        exit;
}
private function savemessage_text($message_number)
{
        $lines=file($this->filename);
        $d=explode("<>", trim($lines[$message_number]));
        $s=str_replace('<p>',chr(13).chr(10),$d[4]);
        $s=str_replace('</p>','',$s);
        $s=str_replace('<br>',chr(13).chr(10),$s);
        $s='From: '.$d[5].' ('.$d[2].')'.chr(13).chr(10).'I.P.: '.$d[0].chr(13).chr(10).'Subject: '.htmlspecialchars_decode($d[1]).chr(13).chr(10).'Date: '.$d[3].chr(13).chr(10).str_repeat("_",45).chr(13).chr(10).htmlspecialchars_decode($s);
        $f='message'.$message_number.'.rtf';
        @header("Content-type: application/text");
        @header("Content-Disposition: attachment; filename=$f");
        echo $s;
        exit;
}
private function delete_message($message_number,$str)
{
        $stmp='';
        $f=file($this->filename);
        $c=count($f);
        for($i=0; $i<$c; $i++) {
        if (!($i==$message_number)){ $stmp.=$f[$i];}}
        file_put_contents($this->filename,$stmp);
        @header("Location: index.php");
}
private function install_now()
{
        $list= glob("language/*.txt");
		foreach ($list as $t){
			$t=str_replace('language/', '', str_replace('.txt','',$t));
			$option.='<option value="'.$t.'">'.$t.'</option>';
		}
		$option='<select name="language" style="width:158px;border:1px solid #c0c0c0;">'.$option.'</select>';
		$this->build_page('Install');
        $str='<form name="frmInstall" method="POST" style="text-align:left; padding:10px;" action="index.php" OnSubmit="return fw_install()">
        <table cellspacing="4" style="border-top:1px solid #aaaaaa;width:99%; padding: 10px;"><tr><td style="width:50%; border-right:1px solid #FF7F2A; padding:0 10px;">
        <big><u>Install:</u></big><table style="margin:10px;width:300px;"><tr><td>User:</td><td><input type="text" style="border:1px solid #c0c0c0;" name="setname" size="20"></td></tr>
        <tr><td><a href="#" onclick="javascript:fw_generatePW()">Password</a>:</td><td><input type="text" style="border:1px solid #c0c0c0;" name="setpassword" size="20"></td></tr>
		<tr><td>Language:</td><td>'.$option.'</td></tr>
		</table><td style="padding:0 20px;"><span style="color:red;"><b>Important!</b></span><br />Before install set permission to "0777" or "777" of the followings:
        <ul style="list-style-type:disc;"><li>file=> mail/database/db.php;</li><li>file=> mail/database/settings.php;</li><li>file=> mail/database/config.php;</li><li>file=> mail/script/mail.js;</li></ul>
        </td></tr>';
        $str.='</td></tr></table><table cellspacing="4" style="border-top:1px solid #aaaaaa;width:99%; padding: 10px;"><tr><td style="padding-top:5px; text-align:center;"><input type="submit" value="Submit" name="B1">&nbsp;&nbsp;<input type="reset" value="Reset" name="B2"></td></tr></table></form>';
        echo $str;
        $this->build_footer();
}
private function write_configuration()
{
        $name=$this->strip_slashes($_POST['setname']);
        $pw=$this->strip_slashes($_POST['setpassword']);
		$language=$this->strip_slashes($_POST['language']);
        $selfurl = strtolower(getenv("HTTP_HOST"));
        if(strpos($selfurl,'www.')===0){$selfurl=substr($selfurl,4);}
        $handle=fopen($this->configfile,'w');
        fwrite($handle,'<?php exit; ?>');
        fwrite($handle,"\n");
        fwrite($handle, $selfurl.'< >'.$name.'< >'.md5($pw).'< >'.$language);
        fwrite($handle,"\n");
        fclose($handle);
		$lang=file('language/'.$language.'.txt',FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
		$lang=array_slice($lang,7);
		$f=file_get_contents('database/contact.txt');
		$arr=array('__NAME__','__EMAIL__','__SUBJECT__','__MESSAGE__','__TYPE__','__VERIFICATION__','__SEND__','__FIELDSMANDATORY__','__INBOX__');
		$f=str_replace($arr,$lang,$f);
		$f=addslashes($f);
		$f='document.write("'.str_replace("\r","",str_replace("\n",'\n',$f)).'");';
		$f='function fw_trim(str){return str.replace(/^\s\s*/, \'\').replace(/\s\s*$/, \'\');}function validateForm(){document.getElementById(\'fw_feedback\').innerHTML=\'\';var x=fw_trim(document.getElementById(\'fw_contact_name\').value).length+fw_trim(document.getElementById(\'fw_contact_message\').value).length+fw_trim(document.getElementById(\'fw_contact_subject\').value).length+fw_trim(document.getElementById(\'fw_contact_from\').value).length+fw_trim(document.getElementById(\'fw_contact_captcha\').value).length;if((x>5000)||(x<10)){return false;}return true;}function fw_image(){document.getElementById(\'fw_captcha_img\').contentWindow.location.reload(true);}'.$f;
		file_put_contents('script/mail.js',$f);
        if(filesize($this->filename)<10){file_put_contents($this->filename,str_replace('DATE',date('d.m.Y H:i'),file_get_contents('database/db.txt')));}
        @header("Location: index.php");
}
private function strip_slashes($str)
{
        return ((get_magic_quotes_gpc())? stripslashes($str) : $str);
}
private function build_footer()
{
        echo '<div id="bottom"><a style="font-weight:500;color:#888888;" target="_blank" href="http://ramui.com/">PHP contact-form</a> created by; http://ramui.com.</div></div></center></body></html>';
        exit;
}
public function get_query()
{
        if(!(filesize($this->configfile)>10)){
            if (!((empty($_POST['setpassword']))&&(empty($_POST['setname'])))){
                $this->write_configuration();
                return;}
            $this->install_now();
            return;}

        $configline=file($this->configfile);
        $config=explode('< >', $this->strip_slashes($configline[1]));
        $this->url=$config[0];
        $this->user=$config[1];
        $this->pw=trim($config[2]);
		$this->language=trim($config[3]);

        if ((!(empty($_GET['sendmail'])))&&($_GET['sendmail'])&&($this->validate_url())){
            $this->send_mail();
            return;}

      if (count(file($this->filename))<2){
            $this->show_empty();
            return;}

        if ($this->validate_user()){
        $query= explode("M" , @$_GET['qur']);
        switch ($query[0]){
            case "0":
                $this->show_list($query[2]);
            break;
            case "1":
                $this->show_message($query[1]);
            break;
            case "2":
                $this->delete_message($query[1],$query[3]);
            break;
            case "3":
                $this->savemessage_text($query[1]);
            break;
            case "4":
                $this->savemessage_html($query[1]);
            break;
            case "5":
                $this->log_out();
            break;
            default :
                $this->show_list(1);}
        }
        else {$this->log_in();}
}

private function mymail($n, $f, $s, $m)
{
        $msg=$_SERVER['REMOTE_ADDR']."<>".$s."<>".$f."<>".gmdate('M d, H:i')."<>".$m."<>".$n;
        $handle = @fopen ($this->filename, 'a');
        @fwrite($handle,$msg);
        @fwrite($handle,"\n");
        return @fclose($handle);
}
private function send_mail()
{
        $errors='';
		$lang=file('language/'.$this->language.'.txt',FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
		if(!(bin2hex($_SESSION['captcha_code']) == bin2hex($_POST['captcha_code']) && !empty($_SESSION['captcha_code'] ))){$errors.=addslashes(trim($lang[0])).'\n';}
        $subject = htmlspecialchars( $this->strip_slashes($_POST["subject"]));
        if(empty($subject)){$subject="none";}
		$message = htmlspecialchars( $this->strip_slashes($_POST["message"]));
		if(strlen($message)<10){$errors.=addslashes(trim($lang[1])).'\n';}
		if(strlen($message)>3000){$errors.=addslashes(trim($lang[2])).'\n';}
        $message = "<p>".htmlspecialchars( $this->strip_slashes($_POST["message"]))."</p>";
        $message = str_replace("\r","",str_replace ("\n","</p><p>",$message));
        $from = htmlspecialchars( $this->strip_slashes($_POST["from"]));
		if(!preg_match('/^([a-zA-Z0-9\-\._@]){7,110}$/',$from)){$errors.=addslashes(trim($lang[3])).'\n';}
        $name = htmlspecialchars( $this->strip_slashes($_POST["name"]));
		if(strlen($name)<3){$errors.=addslashes(trim($lang[4])).'\n';}
		if(!empty($errors)){
			echo '<script>alert("'.$errors.'");</script>';exit;
		}
        if($this->mymail($name, $from, $subject, $message)){
            unset($_SESSION['captcha_code']);
            echo '<script>parent.document.getElementById("fw_feedback").innerHTML="<span style=\"color:green; background:#ffffff;\">'.addslashes(trim($lang[5])).'</span>";</script>';}
        else{echo '<script>parent.document.getElementById("fw_feedback").innerHTML="<span style=\"color:red; background:#ffffff;\">'.addslashes(trim($lang[6])).'</span>";</script>';}
        exit;
}
}
session_start();
header('Content-Type: text/html; charset=utf-8');
$page=new admin();
$page->get_query();
?>